
local pnlMain = nil;
local pnlMainDNDId = 204;

local pnlPlayer = nil;
local pnlPlayerDescr = nil;

local btnShowHide = nil;
local btnShowHideId = 206;

local TYPE_RAID = 0;
local TYPE_GROUP = 1;
local TYPE_SOLO = 2;

local totalCheckTimer = 0;
local players = {};
local movePlayer = nil;

local IsFramesShown = true;



local MODE_NORMAL = 1;
local MODE_FOOD = 2;
local MODE_POTS = 3;
local MODES = {' ', ' ', ' ', ''};
local Mode = MODE_NORMAL;

function OnEVENT_SECOND_TIMER(params)
	ClearChat();
	if (Self == nil) then 
		if InitAvatar() then
			RegisterAll();
		end
	end
	
	totalCheckTimer = totalCheckTimer + 1;
	if totalCheckTimer == TotalUpdateInterval then
		CheckRaid();
		totalCheckTimer = 0;
	end
end

function CheckRaid()
	--Log( 'full check' );
	for k, v in players do
		UpdatePlayer ( v );
	end
end

function ShowRaidFrames ( show )
	if show then
		--raid:Show(true);
		--stateMainForm:GetChildChecked("ContextRaidPlate", false):Show ( true );
		common.StateLoadManagedAddon( "ContextRaidPlate" );
		common.StateLoadManagedAddon( "ContextPartyPlate" );
		pnlMain:Show ( false )
		--Log('  .   /raidhide');
	else
		common.StateUnloadManagedAddon( "ContextRaidPlate" );
		common.StateUnloadManagedAddon( "ContextPartyPlate" );
		pnlMain:Show ( true )
		ResizeGrid();
	end
end
	

function OnEVENT_UNKNOWN_SLASH_COMMAND(params)
	local cmd = WStringToString(params.text);
	if (cmd == '/gridresetposition') then
		Log('/gridreset - Resetting grid to position 200:200');
		local Placement = pnlMain:GetPlacementPlain()
		Placement.posY = 200;
		Placement.posX = 200;
		pnlMain:SetPlacementPlain(Placement) 
		local Placement = btnShowHide:GetPlacementPlain()
		Placement.posY = 200;
		Placement.posX = 200;
		btnShowHide:SetPlacementPlain(Placement) 
		return;
	end
	
	if (cmd == '/raidshow') then
		ShowRaidFrames(true)
		return;
	end
	
	if (cmd == '/raidhide') then
		ShowRaidFrames(true)
		
		--Log('  .   /raidshow');
		--stateMainForm:GetChildChecked("ContextRaidPlate", false):Show ( false );
		--raid:Show(false)
		return;
	end;
	
	if ( cmd == '/rc' ) then
		if raid.IsExist() and raid.IsLeader() then
			raid.StartReadyCheck();
		elseif group.IsLeader() then
			group.StartReadyCheck();
		end
		return
	end
	
	if ( cmd == '/gridreset' ) then
		ResizeGrid();
		return;
	end
	
	if ( cmd == '/raidpot' ) then
		CheckRaidBuffs( false );
		return
	end
	
	if ( cmd == '/raidpotshow' ) then
		CheckRaidBuffs( true );
		return
	end
end

function CheckRaidBuffs( display )
	local allClear = true;
	local names = '';
	Log('  ----');
	for k, v in players do
		if v.id then 
			local haveGood = false;
			local buffs = object.GetBuffs(v.id);
			for k,buff in buffs do	
				local b = object.GetBuffInfo( buff );
				local name = WStringToString(b.name);
				
				for i1, item in GoodPots do
					if item ~= '' then
						if string.find(name, item) then	
							if display then Log(v.name..' = '.. name ); end
							local haveBad = false;
							for i2, item2 in BadPots do
								if item2 ~= '' and string.find(name, item2) then
									haveBad = true;
									allClear = false;
									--Log(name..' > '.. item2 ..' = '..' bad');
									break;
								end
							end
							haveGood = not haveBad;
						end
					end
				end
			end
			
			if not haveGood then
				names = names .. v.name .. ' ';
				allClear = false;
			end
		end
	end
	
	if allClear then
		Log('   ! ;)');
	else 
		Log(' : '.. names );
	end
end

function PlayerById ( id )
	if id == nil then return false; end;
	if not object.IsExist ( id ) then return false; end;
	local name = WStringToString(object.GetName( id ));
	if name == '' then return false; end;
	for k, v in players do
		if k == name then
			if v.id == nil then
				v.id = id;
			end;
			
			return v;
		end
	end
	
	return false;
end

function FindInfoBySender ( sender ) 
	for k, v in players do
		if v.button:GetName() == sender:GetName() then
			return v;
		end
	end
	
	return false;
end

function OnButtonClick ( params )
	local spell = PickSpellByButton ( MB_LEFT, params )
	if (not spell)  then
		return
	end
	
	if not SelectTargetFromClick ( params , spell) then
		return
	end
	
	if spell == 'MOVE' then
		if raid.IsExist() then
			if not movePlayer then
				movePlayer = FindInfoBySender( params.widget );
				movePlayer.pnlRC:Show( true );
				movePlayer.pnlRC:SetBackgroundColor( COLOR_RC_UNK )
				return
			else 
				local exPlayer = FindInfoBySender( params.widget );
				Log(' : '..movePlayer.name .. ' <> '..exPlayer.name );
				raid.SwapMembers( StringToWString(movePlayer.name), StringToWString(exPlayer.name) )
				movePlayer.pnlRC:Show( false );
				movePlayer = nil;
			end
		end
		return
	else 	
		if movePlayer ~= nil then
			movePlayer.pnlRC:Show( false );
			movePlayer = nil;
		end
	end
	
	UseSkill ( spell )
end

function PickSpellByButton ( button, params )
	local Shift = common.GetBitAnd( params.kbFlags, KBF_SHIFT ) ~= 0;
	local Ctrl = common.GetBitAnd( params.kbFlags, KBF_CTRL ) ~= 0;
	local Alt = common.GetBitAnd( params.kbFlags, KBF_ALT ) ~= 0;
	if button == MB_LEFT then
		if (Shift and LeftShiftButtonSkill) then
			return LeftShiftButtonSkill;
		end
			
		if (Ctrl and LeftCtrlButtonSkill) then
			return LeftCtrlButtonSkill;
		end
		
		if Alt then
			return 'MOVE';
		end
			
		return LeftButtonSkill;
	else 
		if (Shift and RightShiftButtonSkill) then
			return RightShiftButtonSkill;
		end
		
		if (Ctrl and RightCtrlButtonSkill) then
			return RightCtrlButtonSkill;
		end
		
		if Alt then
			return 'MENU';
		end;
		
		return RightButtonSkill;
	end
	
	return false;
end

function SelectTargetFromClick ( params, spell )
	if not spell then
		return false;
	end;
	
	if spell == 'MENU' then
		return true;
	end;
	
	local i =  FindInfoBySender( params.widget );
	local target = i.id;
	if (spell == 'TARGET') then
		avatar.SelectTarget ( i.id );
		return false;
	end
	
	
	if (spell == 'ASSIST') then
		avatar.SelectTarget ( i.id );
		local target = unit.GetTarget(i.id);
		if (target ~= nil) then
			avatar.SelectTarget ( target );
		end
		return false;
	end
	
	if ( target ~= nil  and object.IsExist ( target ) and avatar.GetTarget ~= target ) then
		avatar.SelectTarget ( target );
	end
	return true;
end

function OnRightClick( params )
	local spell = PickSpellByButton ( MB_RIGHT, params )
	if (not spell)  then
		return
	end
	
	if not SelectTargetFromClick ( params , spell) then
		return
	end
	
	UseSkill ( spell )
end

function TryGetMemberFromGroup ( pl, group ) 
	for idx, member in group do
		local memberName = WStringToString(member.name);
		if memberName == pl.name then
			return member;
		end
	end
	
	return nil;
end

function TryGetMember ( pl )
	if (raid.IsExist()) then
		local raid = raid.GetMembers();
		for k, group in raid do
			local member = TryGetMemberFromGroup ( pl, group );
			if member ~= nil then
				return member;
			end
		end
	else 
		local gr = group.GetMembers();
		return TryGetMemberFromGroup ( pl, gr );
	end
	
	return nil;
end

function UpdatePlayer ( pl )
	if pl.id == nil or pl.state == RAID_MEMBER_STATE_FAR then
		local t = TryGetMember ( pl );
		if (t ~= nil and t.id ~= nil) then
			pl.id = t.id;
			pl.state = t.state;
		end
	end
	
	if (pl.id ~= nil and object.IsExist(pl.id) and unit.IsPlayer( pl.id )) then
		local params = {};
		params.unitId = pl.id;
		OnUnitHPChanged(params);
		OnUnitManaChanged(params);
	end
	
	UpdatePosition ( pl );
end

function PlacePlayer ( col, row , pl)
	if pl == nil then return end
	local name = WStringToString(pl.name);
	local id = name;
	if players[id] ~= nil then return end
	
	local panel = mainForm:CreateWidgetByDesc( pnlPlayerDescr )
	pnlMain:AddChild(panel);
	
	players[id] = {};
	players[id].panel = panel;
	players[id].player = pl;
	players[id].id = pl.id;
	players[id].name = name;
	
	local RL = raid.IsExist() and WStringToString(raid.GetLeaderName()) == name;
	
	
	local health = 100;
	local mana = 100;
	local color =  COLOR_OFFLINE;
	if (pl.state == RAID_MEMBER_STATE_FAR) then
		color = COLOR_FAR;
	elseif (pl.state == RAID_MEMBER_STATE_OFFLINE) then
		color = COLOR_OFFLINE;
	else
		if (pl.id ~= nil) then
			color = UnitToClsColor( pl.id);
		end
	end
	players[id].color = color;
	players[id].clsColor = UnitToClsColor( pl.id );
	players[id].manaColor = ManaType2Color( pl.id );

	local Placement = panel:GetPlacementPlain();
	Placement.sizeX = PanelWidth;--math.floor(PanelWidth * health / 100);
	Placement.sizeY = PanelHeight;
	Placement.posX = 14 + (PanelInterval + PanelWidth) * row;
	Placement.posY = 14 + (PanelInterval + PanelHeight) * col ;
	panel:SetPlacementPlain(Placement);
	panel:SetBackgroundColor( COLOR_BACKGROUND );
	panel:SetName( 'pnlBackground'..tostring(col)..tostring(row));
	
	local btnSelector = panel:GetChildChecked("btnSelector", false);
	Placement.posX = 0;
	Placement.posY = 0;
	Placement.sizeX = PanelWidth;
	Placement.sizeY = PanelHeight;
	btnSelector:SetPlacementPlain(Placement);
	btnSelector:Show ( true )
	btnSelector:SetName( 'btnSelector'..tostring(col)..tostring(row));
	players[id].button = btnSelector;
	
	local pnlHP = panel:GetChildChecked("pnlHP", false);
	pnlHP:SetPlacementPlain(Placement);
	pnlHP:SetBackgroundColor( color );
	pnlHP:Show ( true );
	players[id].pnlHP = pnlHP;
	
	local pnlMana = panel:GetChildChecked("pnlMana", false);
	Placement.posX = 0;
	Placement.posY = PanelHeight - ManaHeight;
	Placement.sizeX = PanelWidth;
	Placement.sizeY = ManaHeight;
	pnlMana:SetPlacementPlain(Placement);
	pnlMana:SetBackgroundColor( players[id].manaColor );
	pnlMana:Show ( ManaHeight > 0 );
	players[id].pnlMana = pnlMana;
	
	local lblName = panel:GetChildChecked("lblName", false);
	local txt = players[id].name;
	if RL then txt = '*'..txt; end
	SetValue ( lblName, txt );
	players[id].lblName = lblName;
	
	local hpText = panel:GetChildChecked("lblHP", false);
	Placement = hpText:GetPlacementPlain();
	Placement.posY = Line2PosY;
	hpText:SetPlacementPlain(Placement);
	SetValue ( hpText, tostring(health)..'%');
	players[id].hpText = hpText;
	
	local pnlRC = panel:GetChildChecked("pnlRC", false);
	local Placement = pnlRC:GetPlacementPlain();
	Placement.posX = 0;
	Placement.posY = math.floor(PanelHeight - ReadyCheckSize / 2) - 4 - ManaHeight;
	Placement.sizeX = ReadyCheckSize;
	Placement.sizeY = ReadyCheckSize;
	pnlRC:SetPlacementPlain(Placement);
	pnlRC:SetBackgroundColor(COLOR_RC_NO);
	pnlRC:Show ( false )
	players[id].pnlRC = pnlRC;
	
	Placement.posX = 0;
	Placement.posY = 0;
	Placement.sizeY = CornerIconSize;
	Placement.sizeX = CornerIconSize;
	
	players[id].pnlLeftTopBuff = panel:GetChildChecked('pnlLeftTopBuff', false);
	players[id].pnlRightTopBuff = panel:GetChildChecked('pnlRightTopBuff', false);
	players[id].pnlLeftBottomBuff = panel:GetChildChecked('pnlLeftBottomBuff', false);
	players[id].pnlRightBottomBuff = panel:GetChildChecked('pnlRightBottomBuff', false);
	players[id].pnlCenterBuff = panel:GetChildChecked('pnlCenterBuff', false);
	
	players[id].pnlLeftTopBuff:SetPlacementPlain ( Placement );
	
	Placement.posX = PanelWidth - CornerIconSize;
	players[id].pnlRightTopBuff:SetPlacementPlain ( Placement );
	
	Placement.posX = 0;
	Placement.posY = PanelHeight - CornerIconSize;
	players[id].pnlLeftBottomBuff:SetPlacementPlain ( Placement );
	
	Placement.posX = PanelWidth - CornerIconSize;
	Placement.posY = PanelHeight - CornerIconSize;
	players[id].pnlRightBottomBuff:SetPlacementPlain ( Placement );
	
	--Placement = players[id].pnlCenterBuff:GetPlacementPlain();
	Placement.posX = math.floor(PanelWidth / 2 -  CenterIconSize / 2);
	Placement.posY = math.floor(PanelHeight / 2 - CenterIconSize / 2);
	Placement.sizeX = CenterIconSize;
	Placement.sizeY = CenterIconSize;
	players[id].pnlCenterBuff:SetPlacementPlain ( Placement );
	
	panel:Show ( true )
	panel:Enable( players[id].id ~= nil );
	
	if (players[id].id == nil ) then
		panel:SetBackgroundColor( COLOR_OFFLINE );
		SetValue (hpText, 'OFFLINE');
	end
	
	UpdatePlayer ( players[id] );
end

function ResizeGridA( cols, rows )
	local Placement = pnlMain:GetPlacementPlain();
	Placement.sizeX = 24 + (PanelWidth + PanelInterval)  * cols;
	Placement.sizeY = 25 + (PanelHeight + PanelInterval )* rows;
	pnlMain:SetPlacementPlain(Placement);
end

function FillGroup ( gr, idx )
	for k, val in gr do
		PlacePlayer (k, idx, val);
	end
end

function FillGrid( data, _type)
	local c = 0;
	if _type == TYPE_RAID then
		--data   
		for k, v in data do
			if ( c ~= k ) then
				c = math.max ( c, k  );
				ResizeGridA ( c + 1, 6 );
			end
			FillGroup ( v, k )
		end
	elseif _type == TYPE_GROUP then
		FillGroup ( data, 0 );
	else
		local i = {};
		i.id = Self;
		i.name = StringToWString(SelfName);
		i.state = RAID_MEMBER_STATE_NEAR;
		PlacePlayer (0, 0, i);
	end
end

function ResizeGrid()
	for k, v in players do
		v.panel:DestroyWidget();
	end 
	
	players = {};
	
	if (raid.IsExist()) then
		ResizeGridA(1, 6);
		FillGrid(raid.GetMembers(), TYPE_RAID);
		return;
	end
	
	local gr = group.GetMembers();
	if (gr ~= nil) then
		ResizeGridA(1, table.getn(gr) + 1)
		FillGrid(gr, TYPE_GROUP);
		return;
	end
	
	ResizeGridA( 1 , 1 );
	FillGrid( false , TYPE_SOLO);
end

function OnRaidGroupChange()
	ResizeGrid();
end

function ClearRC()
	for k, v in players do 
		v.pnlRC:Show ( false );
	end
end

function SetRCDisabled( name )
	for k, v in players do
		v.pnlRC:Show ( true ) 
		if ( v.name == name) then
			v.pnlRC:SetBackgroundColor ( COLOR_RC_OK );
		else
			v.pnlRC:SetBackgroundColor ( COLOR_RC_UNK );
		end
	end
end

function OnReadyCheckStarted(params)
	SetRCDisabled(WStringToString (params.initiatorName ));
end

function OnReadyCheckEnded()
	ClearRC();
end

function UpdateRC( rci )
	for k, v in rci.members do
		local name = WStringToString(v.name);
		local state = v.state;
		
		local pl =  players[name];
		if (pl) then
			local pnlRC = pl.pnlRC;
			if state == READY_CHECK_READY_STATE_READY then
				pnlRC:SetBackgroundColor ( COLOR_RC_OK );
			elseif state == READY_CHECK_READY_STATE_UNKNOWN then
				pnlRC:SetBackgroundColor ( COLOR_RC_UNK );
			else
				pnlRC:SetBackgroundColor ( COLOR_RC_NO );
			end
		end
	end
end

function OnReadyCheckInfoChanged()
	local rci = raid.GetReadyCheckInfo()
	if rci then
		if rci.isInProgress then
			UpdateRC ( rci ) 
		end
	else
		local rci = group.GetReadyCheckInfo()
		
		if rci then
			if rci.isInProgress then
				UpdateRC( rci );
			end
		end
	end
end

function OnUnitHPChanged(params)
	local id = params.unitId;
	local p = PlayerById ( id );
	if not p then return; end
	local hp = 0;
	--if not object.IsDead( id ) then hp =  unit.GetHealthPercentage( id ); end
	if not object.IsDead( id ) then hp =  object.GetHealthInfo( id ).valuePercents; end
	local Placement = p.pnlHP:GetPlacementPlain();
	Placement.sizeX = math.floor(PanelWidth * hp / 100);
	Placement.sizeY = PanelHeight;
	p.pnlHP:SetPlacementPlain(Placement);
	SetValue ( p.hpText, tostring(hp)..'%');
end

function OnUnitManaChanged(params)	
	local id = params.unitId;
	local p = PlayerById ( id );
	if not p then return; end

	local mana = unit.GetManaPercentage( id );
	local pnlMana = p.pnlMana;
	local Placement = pnlMana:GetPlacementPlain();
	Placement.sizeX = math.floor(PanelWidth * mana / 100);
	pnlMana:SetPlacementPlain(Placement);
end

function UpdatePosition ( pl ) 
	if pl.id ~= nil then
		local tp = nil;
		if not object.IsExist( pl.id ) then 
			SetValue (pl.hpText, 'FAR');
		else 
			tp = object.GetPos(pl.id);
		end
		
		local range = PosRange(avatar.GetPos(), tp);
		
		pl.panel:Enable ( true );
		local newColor = pl.color;
		if range > FarLimit then
			pl.state = RAID_MEMBER_STATE_FAR;
			newColor = COLOR_FAR;
		else
			pl.state = RAID_MEMBER_STATE_NEAR;
			newColor = UnitToClsColor(pl.id);
		end
		
		if (newColor ~= pl.color) then
			pl.pnlHP:SetBackgroundColor(newColor);
			pl.color = newColor;
		end
	end
end

function OnSelfPosChanged()
	for k, pl in players do
		UpdatePosition ( pl )
	end
end

function OnRaidMemberPosChanged(params)
	local id = params.id;
	if ( params.id == Self ) then
		OnSelfPosChanged()
		return
	end
	
	local pl = PlayerById(id);
	if pl then UpdatePosition ( pl ) end
end

function ShowBuff( panel, b)
	panel:SetBackgroundTexture ( b.texture );
	panel:Show ( true );
end

function ClearPanelBuffs ( pl )
	pl.pnlLeftTopBuff:Show ( false );
	pl.pnlRightTopBuff:Show ( false );
	pl.pnlLeftBottomBuff:Show ( false );
	pl.pnlRightBottomBuff:Show ( false );
	pl.pnlCenterBuff:Show ( false );
end

function OnBuffChanged( params )

	if Mode ~= MODE_NORMAL then
		return
	end
	
	local id = params.objectId;
	local pl = PlayerById ( id );
	if not pl then return end
	
	ClearPanelBuffs(pl);
	
	local activeBuffs = object.GetBuffs( id );
	for k,buff in activeBuffs do
		local b = object.GetBuffInfo( buff );
		if b ~= nil then
			local name = WStringToString(b.name);
			
			local caster = b.producer.casterId;
			local positive = b.isPositive;
			
			if inTableString (RaidDebuffs, name ) then
				ShowBuff ( pl.pnlCenterBuff, b)
			end
				
			local parse = (not positive) or (caster == Self and ShowOnlySelfBuffs) or (not ShowOnlySelfBuffs);
			if ( parse ) then
				if inTableString( LeftTopCornerEffect, name ) then
					ShowBuff ( pl.pnlLeftTopBuff , b)
				elseif inTableString( RightTopCornerEffect, name ) then
					ShowBuff ( pl.pnlRightTopBuff, b)
				elseif inTableString( LeftBottomCornerEffect, name ) then
					ShowBuff ( pl.pnlLeftBottomBuff, b)
				elseif inTableString( RightBottomCornerEffect, name ) then
					ShowBuff ( pl.pnlRightBottomBuff, b)
				end
			end;
		end
	end
end

function OnRaidInvite(params)
	raid.Accept()
	Log('  !');
end

function OnShowButtonClick ( params )
	IsFramesShown = not IsFramesShown;
	ShowRaidFrames( IsFramesShown );
end

function OnShowRightClick ( params )
	Log ( 'not implemented ' )
end

function RegisterAll()
	common.RegisterEventHandler( OnEVENT_UNKNOWN_SLASH_COMMAND, "EVENT_UNKNOWN_SLASH_COMMAND");
	
	common.RegisterEventHandler( OnRaidGroupChange, "EVENT_RAID_APPEARED");
	common.RegisterEventHandler( OnRaidGroupChange, "EVENT_RAID_DISAPPEARED");
	common.RegisterEventHandler( OnRaidGroupChange, "EVENT_GROUP_APPEARED");
	common.RegisterEventHandler( OnRaidGroupChange, "EVENT_GROUP_DISAPPEARED");
	common.RegisterEventHandler( OnRaidGroupChange, "EVENT_RAID_CHANGED");
	common.RegisterEventHandler( OnRaidGroupChange, "EVENT_GROUP_CHANGED");
	
	
	common.RegisterEventHandler( OnRaidMemberPosChanged, "EVENT_PARTY_MEMBER_POSITION_UPDATED");
	common.RegisterEventHandler( OnRaidMemberPosChanged, "EVENT_RAID_MEMBER_POSITION_UPDATED");
	common.RegisterEventHandler( OnSelfPosChanged, "EVENT_AVATAR_POS_CHANGED");
	
	common.RegisterEventHandler( OnReadyCheckStarted, "EVENT_READY_CHECK_STARTED");
	common.RegisterEventHandler( OnReadyCheckInfoChanged, "EVENT_READY_CHECK_INFO_CHANGED");
	common.RegisterEventHandler( OnReadyCheckEnded, "EVENT_READY_CHECK_ENDED");
	
	common.RegisterEventHandler( OnUnitHPChanged, "EVENT_UNIT_HEALTH_PERCENTAGE_CHANGED");
	common.RegisterEventHandler( OnUnitHPChanged, "EVENT_UNIT_DEAD_CHANGED");
	common.RegisterEventHandler( OnUnitHPChanged, "EVENT_UNIT_HEALTH_CHANGED");
	
	
	common.RegisterEventHandler( OnBuffChanged, "EVENT_OBJECT_BUFFS_CHANGED");
	common.RegisterEventHandler( OnRaidInvite, "EVENT_RAID_INVITE");
	
	
	
	if (ManaHeight > 0) then
		common.RegisterEventHandler( OnUnitManaChanged, "EVENT_UNIT_MANA_PERCENTAGE_CHANGED");
		common.RegisterEventHandler( OnUnitManaChanged, "EVENT_UNIT_MANA_CHANGED");
		
	end

	--common.RegisterEventHandler( OnEVENT_AVATAR_PRIMARY_TARGET_CHANGED, "EVENT_AVATAR_PRIMARY_TARGET_CHANGED");
	
	DnD:Init(pnlMainDNDId, pnlMain, nil, true, false, nil);
	DnD:Init(btnShowHideId, btnShowHide, nil, true, false, nil);
	
	ResizeGrid();
	common.RegisterReactionHandler( OnButtonClick, "OnButtonClick" )
	common.RegisterReactionHandler( OnRightClick, "OnRightClick" )
	
	common.RegisterReactionHandler( OnShowButtonClick, "OnShowButtonClick" )
	common.RegisterReactionHandler( OnShowRightClick, "OnShowRightClick" )
	
	if HideStandardRaid then
		common.StateUnloadManagedAddon( "ContextRaidPlate" );
		Log('  .   /raidshow');
	end
	--Log('');
end

function Init()
	pnlMain = mainForm:GetChildChecked("pnlMain", false);
	pnlPlayer = pnlMain:GetChildChecked("pnlBackground", false);
	pnlPlayerDescr = pnlPlayer:GetWidgetDesc();
	
	btnShowHide = mainForm:GetChildChecked("btnShow", false);
	
	if InitAvatar() then
		RegisterAll();
	end
	
	common.RegisterEventHandler( OnEVENT_SECOND_TIMER, "EVENT_SECOND_TIMER");
end
--------------------------------------------------------------------------------
Init()
--------------------------------------------------------------------------------
